/********************************** (C) COPYRIGHT *******************************
 * File Name          : lwns_multinetflood_example.c
 * Author             : WCH
 * Version            : V1.0
 * Date               : 2021/11/10
 * Description        : multinetflood鲥緺鴫
 *********************************************************************************
 * Copyright (c) 2021 Nanjing Qinheng Microelectronics Co., Ltd.
 * Attention: This software (modified or not) and binary are used for 
 * microcontroller manufactured by Nanjing Qinheng Microelectronics.
 *******************************************************************************/
#include "lwns_multinetflood_example.h"

//ÿļdebugӡĿأ0Խֹļڲӡ
#define DEBUG_PRINT_IN_THIS_FILE    1
#if DEBUG_PRINT_IN_THIS_FILE
  #define PRINTF(...)    PRINT(__VA_ARGS__)
#else
  #define PRINTF(...) \
    do                \
    {                 \
    } while(0)
#endif

/*
 * ĵĵַΪ2ֽu16͡
 */
static uint8_t subaddrs_index = 0;                 //Ͷĵַ
#define SUBADDR_NUM    3                           //ĵַ
static uint16_t subaddrs[SUBADDR_NUM] = {1, 2, 3}; //ĵַ

static uint8_t  TX_DATA[LWNS_DATA_SIZE] = {0}; //󳤶շ
static uint8_t  RX_DATA[LWNS_DATA_SIZE] = {0}; //󳤶շ
static uint16_t lwns_multinetflood_ProcessEvent(uint8_t task_id, uint16_t events);
static void     multinetflood_recv(lwns_controller_ptr ptr, uint16_t subaddr, const lwns_addr_t *sender, uint8_t hops); //鲥緺ջص
static void     multinetflood_sent(lwns_controller_ptr ptr);                                                            //鲥緺鷢ɻص

static lwns_multinetflood_controller multinetflood; //鲥緺ƽṹ

static uint8_t multinetflood_taskID; //鲥緺id

/*********************************************************************
 * @fn      multinetflood_recv
 *
 * @brief   lwns multinetfloodջص
 *
 * @param   ptr     -   νյmultinetfloodƽṹָ.
 * @param   subaddr -   νյݵĶĵַ.
 * @param   sender  -   νյݵķߵַָ.
 * @param   hops    -   νյݵĴӷͷڵ㾭.
 *
 * @return  None.
 */
static void multinetflood_recv(lwns_controller_ptr ptr, uint16_t subaddr, const lwns_addr_t *sender, uint8_t hops)
{
    uint8_t len;
    len = lwns_buffer_datalen();    //ȡǰյݳ
    lwns_buffer_save_data(RX_DATA); //ݵû
    PRINTF("multinetflood %d rec from %02x %02x %02x %02x %02x %02x\n",
           get_lwns_object_port(ptr),
           sender->v8[0], sender->v8[1], sender->v8[2], sender->v8[3],
           sender->v8[4], sender->v8[5]); //fromΪյݵķͷַ
    PRINTF("subaddr:%d,data:", subaddr);
    for(uint8_t i = 0; i < len; i++)
    {
        PRINTF("%02x ", RX_DATA[i]); //ӡ
    }
    PRINTF("\n");
}

/*********************************************************************
 * @fn      multinetflood_sent
 *
 * @brief   lwns multinetfloodɻص
 *
 * @param   ptr     -   ηɵ鲥緺ƽṹָ.
 *
 * @return  None.
 */
static void multinetflood_sent(lwns_controller_ptr ptr)
{
    PRINTF("multinetflood %d sent\n", get_lwns_object_port(ptr));
}

/**
 * lwns 鲥緺صṹ壬עص
 */
static const struct lwns_multinetflood_callbacks multinetflood_callbacks =
    {multinetflood_recv, multinetflood_sent};

/*********************************************************************
 * @fn      lwns_multinetflood_process_init
 *
 * @brief   lwns multinetflood̳ʼ.
 *
 * @param   None.
 *
 * @return  None.
 */
void lwns_multinetflood_process_init(void)
{
    multinetflood_taskID = TMOS_ProcessEventRegister(lwns_multinetflood_ProcessEvent);
    for(uint8_t i = 0; i < LWNS_DATA_SIZE; i++)
    {
        TX_DATA[i] = i;
    }
    lwns_multinetflood_init(&multinetflood,
                            137,               //һ˿ںΪ137鲥緺ṹ
                            HTIMER_SECOND_NUM, //ȴתʱ
                            1,                 //ڵȴڼ䣬յͬݰȡݰķ
                            3,                 //ת㼶
                            FALSE,             //ڵȴתУյµҪתݰݰ̷ͳȥǶFALSEΪ̷ͣTRUEΪ
                            50,                //ֵָһ࣬űڴڱݰСֵڴֵΪϻָոݰ
                            //ͬʱֵҲжΪݰĲֵͬһڵݰŲԱڴеĴ࣬ȴֵ
                            //磬ڴбΪ10ݰΪ60ֵΪ50ڵڴʱõ50ԽᱻΪΪµݰ
                            //ֻΪ59ֵΪ49СڸֵŻᱻա
                            TRUE,                      //ǷתĿǱݰmeshǷrelayܡ
                            subaddrs,                  //ĵĵַָ
                            SUBADDR_NUM,               //ĵַ
                            &multinetflood_callbacks); //0ʧܡ1򿪳ɹ
#if 1
    tmos_start_task(multinetflood_taskID, MULTINETFLOOD_EXAMPLE_TX_PERIOD_EVT,
                    MS1_TO_SYSTEM_TIME(1000));
#endif
}

/*********************************************************************
 * @fn      lwns_multinetflood_ProcessEvent
 *
 * @brief   lwns multinetflood Task event processor.  This function
 *          is called to process all events for the task.  Events
 *          include timers, messages and any other user defined events.
 *
 * @param   task_id - The TMOS assigned task ID.
 * @param   events - events to process.  This is a bit map and can
 *                   contain more than one event.
 *
 * @return  events not processed.
 */
uint16_t lwns_multinetflood_ProcessEvent(uint8_t task_id, uint16_t events)
{
    if(events & MULTINETFLOOD_EXAMPLE_TX_PERIOD_EVT)
    {
        uint8_t temp;
        temp = TX_DATA[0];
        for(uint8_t i = 0; i < 9; i++)
        {
            TX_DATA[i] = TX_DATA[i + 1]; //λݣԱ۲Ч
        }
        TX_DATA[9] = temp;
        lwns_buffer_load_data(TX_DATA, sizeof(TX_DATA)); //Ҫ͵ݵ
        if(subaddrs_index >= SUBADDR_NUM)
        {
            subaddrs_index = 0;
        }
        lwns_multinetflood_send(&multinetflood, subaddrs[subaddrs_index]); //鲥緺鷢ݵĵַ
        subaddrs_index++;

        tmos_start_task(multinetflood_taskID, MULTINETFLOOD_EXAMPLE_TX_PERIOD_EVT,
                        MS1_TO_SYSTEM_TIME(1000)); //Է
        return events ^ MULTINETFLOOD_EXAMPLE_TX_PERIOD_EVT;
    }

    if(events & SYS_EVENT_MSG)
    {
        uint8_t *pMsg;
        if((pMsg = tmos_msg_receive(task_id)) != NULL)
        {
            // Release the TMOS message
            tmos_msg_deallocate(pMsg);
        }
        // return unprocessed events
        return (events ^ SYS_EVENT_MSG);
    }

    return 0;
}
